using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RGDWCSServices.WMS
{
    public class getEmptyBoxPos:PlatformBase
    {
        /// <summary>入参定义
        /// 入参定义
        /// </summary>
        [Serializable]
        public class PARA : Base.InPara
        {
            private string _wh_id;

            private string _task_no;

            private string _oper_no;
             
            private string _box_loc_no;
            
            public string WH_ID
            {
                get { return this._wh_id; }
                set { this._wh_id = value; }
            }
            
            public string TASK_NO
            {
                get { return this._task_no; }
                set { this._task_no = value; }
            }

            
            public string OPER_NO
            {
                get { return this._oper_no; }
                set { this._oper_no = value; }
            }

            
            public string BOX_LOC_NO
            {
                get { return this._box_loc_no; }
                set { this._box_loc_no = getWMS_LOC_NO( value); }
            }

        }

        /// <summary>出参定义
        /// 出参定义
        /// </summary>
        [Serializable]
        public class DATA : Base.OutPara
        {
            private string _loc_no;

            public string LOC_NO
            {
                get { return this._loc_no; }
                set { this._loc_no = getWCS_LOC_NO(value); }
            }

        }

        /// <summary>入参实体
        /// 入参实体
        /// </summary>
        private PARA _inPara;

        /// <summary>出参实体
        /// 出参实体
        /// </summary>
        private DATA _outPara;

        public getEmptyBoxPos()
        {
            this._inPara = new PARA();
        }

        /// <summary>通知
        /// 通知
        /// </summary>
        /// <param name="IO_TASK_NO">任务单号</param>
        /// <param name="ePLAN_STATUS">任务状态</param>
        /// <param name="sResult">返回结果</param>
        /// <returns></returns>
        public bool Notify( string TASK_NO,string BOX_LOC_NO, out string sResult)
        {
            bool bResult = true;

            sResult = string.Empty;

            string sXmlOut = string.Empty;

            try
            {
                this._inPara.WH_ID = GetWarehouseIndex();

                this._inPara.TASK_NO = TASK_NO;

                this._inPara.OPER_NO = GetOperNo();

                this._inPara.BOX_LOC_NO = BOX_LOC_NO;

                string sXmlIn = this.Serializer<PARA>(this._inPara);

                bResult = this.getEmptyBoxPos(sXmlIn, out sXmlOut);

                //调用服务成功
                if (bResult)
                {
                    this._outPara = this.DeSerialize<DATA>(sXmlOut);

                    bResult = this._outPara.RESULT_FLAG.Equals(Enum.RESULT_FLAG.Success.ToString("d"));

                    sResult = sXmlOut;
                }

                return bResult;
            }
            catch (Exception ex)
            {
                bResult = false;

                sResult = string.Format(ex.Message);
            }

            return bResult;
        }
    }
}
